var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", "../lib/ListOfImages", "../system/Spot", "../system_lib/Metadata", "../system_lib/Script"], function (require, exports, ListOfImages_1, Spot_1, Metadata_1, Script_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PhotoManager = void 0;
    var PhotoManager = (function (_super) {
        __extends(PhotoManager, _super);
        function PhotoManager(env) {
            var _this = _super.call(this, env) || this;
            _this.listOfImages = new ListOfImages_1.ListOfImages(_this, 'Photos', {
                maxImageSideLength: 1920,
                maxImageCount: 12
            });
            _this.photoStream = _this.listOfImages.getIndexedProperty('photoStream');
            _this.listenForPhotos();
            return _this;
        }
        PhotoManager.prototype.listenForPhotos = function () {
            var _this = this;
            PhotoManager.CAMERA_SPOTS.forEach(function (spotPath) {
                var spot = Spot_1.Spot[spotPath];
                var imageProvider = spot.isOfTypeName("DisplaySpot") ||
                    spot.isOfTypeName("MobileSpot");
                if (imageProvider) {
                    imageProvider.subscribe('image', function (sender, message) {
                        _this.listOfImages.acceptImage(message.filePath);
                    });
                }
                imageProvider.subscribe('finish', function () { return _this.listenForPhotos(); });
            });
        };
        PhotoManager.prototype.clear = function () {
            return this.listOfImages.clear(true);
        };
        PhotoManager.CAMERA_SPOTS = [
            'Visitor',
            'Station',
        ];
        __decorate([
            (0, Metadata_1.callable)('Clear all photos'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], PhotoManager.prototype, "clear", null);
        return PhotoManager;
    }(Script_1.Script));
    exports.PhotoManager = PhotoManager;
});
